﻿
Public Class MainForm
	'Private metaCtrl As New Factory.MetadataFactory	
   Private metaEngine As Metamodel.entitiesClient ' Entity.Interface.IMetadata
	Private metaEntity As Metamodel.MetadataEntity
	Private myEntity As EntityEngine.EntityClient

   Private Function InitMetadata() As Metamodel.entitiesClient
      Dim met As New Metamodel.entitiesClient
      If Not String.IsNullOrEmpty(txtUsername.Text) Then
         met.ChannelFactory.Credentials.Windows.ClientCredential = New System.Net.NetworkCredential(txtUsername.Text, txtPassword.Text)
      End If

      met.ClientCredentials.Windows.AllowedImpersonationLevel = Security.Principal.TokenImpersonationLevel.Impersonation
      met.Endpoint.Address = New System.ServiceModel.EndpointAddress(txtAddress.Text & "/services/exact.metadata.svc")
      Return met
   End Function

   Private Sub btnMetadata_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnMetadata.Click
      Try
			If metaEngine Is Nothing Then
				metaEngine = InitMetadata()
			End If
         metaEntity = metaEngine.Retrieve(cboEntity.Text)
			If metaEntity Is Nothing Then
				MsgBox("Entity Not Found", MsgBoxStyle.Critical)
			Else
				MetaTV.Nodes.Clear()
				Dim prop As Metamodel.MetadataProperty
				For Each prop In metaEntity.Interface.Properties
					Dim propNode As New TreeNode(prop.Name)
					If prop.Mandatory Then propNode.ForeColor = Color.Red
               If prop.Name = metaEntity.Interface.KeyProperty Then
                  propNode.ForeColor = Color.DarkMagenta
                  propNode.BackColor = Color.LightBlue
               End If
					propNode.Name = prop.Name
					propNode.Nodes.Add("Mandatory", "Mandatory :" & prop.Mandatory)
					propNode.Nodes.Add("Caption", "Caption :" & prop.Caption)
					propNode.Nodes.Add("Type", "Type :" & prop.Type)
					propNode.Nodes.Add("Length", "Length :" & prop.Length)
					propNode.Nodes.Add("Mandatory", "Mandatory :" & prop.Mandatory)
					propNode.Nodes.Add("Decimal", "Decimal :" & prop.Scale)
					propNode.Nodes.Add("LowerRange", "LowerRange :" & prop.LowerRange)
					propNode.Nodes.Add("UpperRange", "UpperRange  :" & prop.UpperRange)
					propNode.Nodes.Add("Default", "Default:" & prop.DefaultValue)
					propNode.Nodes.Add("SelectionValues", "SelectionValues :" & prop.SelectionValues)
               propNode.Nodes.Add("SecurityContext", "SecurityContext :" & prop.SecurityContextIncluded)
					MetaTV.Nodes.Add(propNode)
				Next
			End If
      Catch ex As Exception
         MsgBox("Entity Not Found", MsgBoxStyle.Critical)
      End Try
   End Sub

   Private Sub btnSelect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSelect.Click
      If Not MetaTV.SelectedNode Is Nothing Then
         If MetaTV.SelectedNode.Level = 1 Then
            txtProperty.Text = MetaTV.SelectedNode.Parent.Name
         Else
            txtProperty.Text = MetaTV.SelectedNode.Name
         End If
      End If
   End Sub

   Private Sub btnAddProp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAddProp.Click
      If Not lstProp.Items.ContainsKey(txtProperty.Text) Then
         Dim ListItem As New ListViewItem
         ListItem.Name = txtProperty.Text
         ListItem.Text = txtProperty.Text & "::" & txtValue.Text
         lstProp.Items.Add(ListItem)
      Else
         MsgBox("Please remove existing property first", MsgBoxStyle.Critical)
      End If
   End Sub

   Private Sub btnRemoveProp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRemoveProp.Click
      For i = 0 To lstProp.SelectedItems.Count - 1
         lstProp.SelectedItems(i).Remove()
      Next
   End Sub

	Private Function InitEntity() As EntityEngine.EntityClient
		Dim ent As New EntityEngine.EntityClient

		If Not String.IsNullOrEmpty(txtUsername.Text) Then
			ent.ChannelFactory.Credentials.Windows.ClientCredential = New System.Net.NetworkCredential(txtUsername.Text, txtPassword.Text)
		End If
		ent.ClientCredentials.Windows.AllowedImpersonationLevel = Security.Principal.TokenImpersonationLevel.Impersonation
		ent.Endpoint.Address = New System.ServiceModel.EndpointAddress(txtAddress.Text & "/services/exact.entity.svc")
		Return ent
	End Function

   Private Sub btnCreate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCreate.Click
      Try
			myEntity = InitEntity()	'New EntityBase(metaEntity.Interface.Name)
			PopulateERList(myEntity.Create(PopulateERData))
			AddStatus("Create Operation completed")
      Catch ex As Exception
			MessageBox.Show("Error Occurred :" & ex.Message, "Entity Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
      End Try

   End Sub

   Private Sub btnRetrieve_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRetrieve.Click
      Try
			myEntity = InitEntity()	' New EntityBase(metaEntity.Interface.Name)
			PopulateERList(myEntity.Retrieve(PopulateERData))
			AddStatus("Retrieve Operation completed")
      Catch ex As Exception
			MessageBox.Show("Error Occurred :" & ex.Message, "Entity Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
      End Try

   End Sub

   Private Sub btnUpdate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnUpdate.Click

      Try
			myEntity = InitEntity()	' New EntityBase(metaEntity.Interface.Name)
         myEntity.Update(PopulateERData)
			PopulateERList(myEntity.Retrieve(PopulateERData))
			AddStatus("Update Operation completed")
      Catch ex As Exception
			MessageBox.Show("Error Occurred :" & ex.Message, "Entity Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
      End Try

   End Sub

   Private Sub btnSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSave.Click
      Try
         myEntity = InitEntity() 'New EntityBase(metaEntity.Interface.Name)
         PopulateERList(myEntity.Save(PopulateERData))
			AddStatus("Save Operation completed")
      Catch ex As Exception
			MessageBox.Show("Error Occurred :" & ex.Message, "Entity Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
      End Try

	End Sub

	Private Sub btnOpenNew_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnOpenNew.Click
		Try
			myEntity = InitEntity()	'New EntityBase(metaEntity.Interface.Name)
			PopulateERList(myEntity.OpenNew(PopulateERData))
			AddStatus("OpenNew Operation completed")
		Catch ex As Exception
			MessageBox.Show("Error Occurred :" & ex.Message, "Entity Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
		End Try
	End Sub

	Private Sub btnValidate_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnValidate.Click
		Try
			myEntity = InitEntity()	'New EntityBase(metaEntity.Interface.Name)
			PopulateERList(myEntity.Validate(PopulateERData))
			AddStatus("Validate Operation completed")
		Catch ex As Exception
			MessageBox.Show("Error Occurred :" & ex.Message, "Entity Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
		End Try
	End Sub

	Private Sub btnDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDelete.Click
		Try
			myEntity = InitEntity()	'New EntityBase(metaEntity.Interface.Name)
			myEntity.Delete(PopulateERData)
			lstProp.Clear()
			AddStatus("Delete Operation completed")
		Catch ex As Exception
			MessageBox.Show("Error Occurred :" & ex.Message, "Entity Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
		End Try
	End Sub


   Private Function PopulateERData() As EntityEngine.EntityData
      Dim newEntity As New EntityEngine.EntityData()
      newEntity.EntityName = metaEntity.Name
      Dim EREntityProp As EntityEngine.PropertyData
      Dim vals As New List(Of EntityEngine.PropertyData)
      For Each itemProp As ListViewItem In lstProp.Items
         EREntityProp = New EntityEngine.PropertyData() With {.Name = itemProp.Name, .Value = Mid(itemProp.Text, InStr(itemProp.Text, ":") + 2)} 'New EntityPropertyData(itemProp.Name, Mid(itemProp.Text, InStr(itemProp.Text, ":") + 2))
         vals.Add(EREntityProp)
      Next
      newEntity.Properties = vals.ToArray()
      Return newEntity
   End Function

   Private Sub PopulateERList(ByVal EREntityProp As EntityEngine.EntityData)
      Dim ListItem As ListViewItem
		lstERProp.Clear()
		lstERProp.Columns.Clear()

      'For i = 0 To EREntityProp.Count - 1
      '	If Not lstERProp.Items.ContainsKey(EREntityProp(i).Name) Then
      '		ListItem = New ListViewItem
      '		ListItem.Name = EREntityProp(i).Name
      '		ListItem.Text = EREntityProp(i).Name & "::" & EREntityProp(i).Value
      '		lstERProp.Items.Add(ListItem)
      '	End If
		'Next
		lstERProp.Columns.Add("Name", 150)
		lstERProp.Columns.Add("Value")

      For i = 0 To EREntityProp.Properties.Length - 1
         If Not lstERProp.Items.ContainsKey(EREntityProp.Properties.ElementAt(i).Name) Then
            ListItem = New ListViewItem

            If Not TypeOf (EREntityProp.Properties.ElementAt(i).Value) Is System.Array Then
               ListItem.Name = EREntityProp.Properties.ElementAt(i).Name
					ListItem.Text = EREntityProp.Properties.ElementAt(i).Name
					ListItem.SubItems.Add(CStr(EREntityProp.Properties.ElementAt(i).Value))
					lstERProp.Items.Add(ListItem)


            End If

         End If
      Next
   End Sub

   Private Sub btnClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClear.Click
      lstProp.Clear()
   End Sub


   Private Sub btnAddList_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAddList.Click
      Dim ListItem As ListViewItem
      For i = 0 To lstERProp.SelectedItems.Count - 1
         ListItem = New ListViewItem
         ListItem.Name = lstERProp.SelectedItems.Item(i).Name
         ListItem.Text = lstERProp.SelectedItems.Item(i).Text
         lstProp.Items.Add(ListItem)
      Next
   End Sub

	Private Sub butGo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butGo.Click
		Dim Entities() As Metamodel.DefinedEntity
		cboEntity.Items.Clear()
		If IsNothing(metaEngine) Then
			metaEngine = InitMetadata()
		End If
		Entities = metaEngine.DefinedEntities()
		For Each Entity As Metamodel.DefinedEntity In Entities
			cboEntity.Items.Add(Entity.Name)
		Next
		AddStatus("Entities retrieved!")
	End Sub

	Public Sub AddStatus(ByVal text As String)
		lstStatus.Items.Add(String.Format("[{0}] {1}", DateTime.Now.ToShortTimeString, text))
	End Sub
End Class
